

//$fn=15;
$fn=150;

/* Base */
diaOuter=200.0;
diaInner=diaOuter-2*3;

/* Settings for 70mm height */
/* */
	height=70;
	gStackable=true;
	howtocalc=81; // FIXME (for 70mm height)
/* */

/* Settings for 35mm height */
/* 
	height=35; //70;
	gStackable=true;
	howtocalc= 81; // FIXME (for 35mm height)
/* */

/* Material Strength */
gMS=2.4;
gMSBottom=4.0;
//gMSBottom=gMS;

/* Adjustments to printing bed size */
gPrintingBedSizeX=210;
gPrintingBedSizeY=135;

/* Drawer */
dl=diaOuter/2;
dw=gPrintingBedSizeY-23; //dl;
//dh=height-23;
dh=height-12;
dli=dl-1*gMS;
dwi=dw-2*gMS;
dhi=dh-1*gMS;
gap=0.5;


/* Drawer */
if (0)
{
	//translate([0, 100, 0])
	drawer();
}


/* Main Body */
if (1)
{
	/* Body */
	//translate([0, 0, height/2])
	intersection()
	{
		mainBody();
	
		translate([0, -(diaOuter-gPrintingBedSizeY)/2, 0])
		cube([gPrintingBedSizeX, gPrintingBedSizeY, 100], center=true);
	}
	
}

/* Drawer */
module drawer()
{

	if (1)
	difference()
	{
		union()
		{
			/* box */
			translate([0, dl/2, dh/2])
			cube([dw, dl, dh], center=true);

			/* Rounded Front */
			translate([0, howtocalc, 0])
			intersection()
			{
				translate([0, 0, height/2])
				mainBodyBaseCyl(gMS/2);
				
				translate([0, -dl/2, dh/2])
				cube([dw, dl, dh], center=true);
			}
		}
		
		/* box -1 */
		translate([0, dl/2-0.56*gMS, dh/2+gMS/2])
		cube([dwi, dli, dhi], center=true);

		/* handle */
		#translate([0, 0, dh-23/2])
		intersection()
		{
			#translate([0, -23, 23/2])
			rotate([90, 0, 0])
			hull()
			{
				translate([-23, 0, 0])
				cylinder(d=23, h=42, center=true);
				translate([23, 0, 0])
				cylinder(d=23, h=42, center=true);
			}	
			
			cube([100, 100, 23/2*2], center=true);
		}
	}
	
}





/* Main Body */
module mainBody()
{
	difference()
	{
		mainBodyBaseCyl(gMSBottom);

		/* Front opening for drawer */
	//	#translate([0, 0, (dh+gap*2)/2])
	//	#translate([0, 0, -(height-gMS)/2])
		translate([0, 0, (dh+gap*2)/2-height/2+gMS])
		cube([dw+gap*2, diaOuter, dh+gap*2], center=true);
	}
	
	/* IF Stackable */
	stackDingsHeight=3.0; // 10.0
	if (gStackable)
	{
		difference()
		{
			translate([0, 0, -stackDingsHeight/2-height/2])
			cylinder(d=diaInner, h=stackDingsHeight, center=true);

			translate([0, 0, -10/2-height/2])
			cylinder(d=diaInner-gMS*2, h=stackDingsHeight, center=true);
		}
	}
	
	/* Rails for drawer */
	//cube([dw+gap*2, dl+gap*2, dh+gap*2], center=true);
	

}

module mainBodyBaseCyl(bottomMS)
{
	difference()
	{
		cylinder(d=diaOuter, h=height, center=true);
		
		translate([0, 0, bottomMS])
		cylinder(d=diaInner, h=height-bottomMS, center=true);
	}
}
